diff --git a/web/pgadmin/tools/sqleditor/static/js/components/sections/Query.jsx b/web/pgadmin/tools/sqleditor/static/js/components/sections/Query.jsx
new file mode 100644
index 000000000..e37f91a8a
--- /dev/null
+++ b/web/pgadmin/tools/sqleditor/static/js/components/sections/Query.jsx
@@ -0,0 +1,401 @@
+/////////////////////////////////////////////////////////////
+//
+// pgAdmin 4 - PostgreSQL Tools
+//
+// Copyright (C) 2013 - 2022, The pgAdmin Development Team
+// This software is released under the PostgreSQL Licence
+//
+//////////////////////////////////////////////////////////////
+import { makeStyles } from '@material-ui/styles';
+import React, {useContext, useCallback, useEffect } from 'react';
+import { QueryToolContext, QueryToolEventsContext } from '../QueryToolComponent';
+import CodeMirror from '../../../../../../static/js/components/CodeMirror';
+import {PANELS, QUERY_TOOL_EVENTS} from '../QueryToolConstants';
+import url_for from 'sources/url_for';
+import { LayoutEventsContext, LAYOUT_EVENTS } from '../../../../../../static/js/helpers/Layout';
+import ConfirmSaveContent from '../dialogs/ConfirmSaveContent';
+import gettext from 'sources/gettext';
+import OrigCodeMirror from 'bundled_codemirror';
+import Notifier from '../../../../../../static/js/helpers/Notifier';
+import { isMac } from '../../../../../../static/js/keyboard_shortcuts';
+
+const useStyles = makeStyles(()=>({
+  sql: {
+    height: '100%',
+  }
+}));
+
+function registerAutocomplete(api, transId, onFailure) {
+  OrigCodeMirror.registerHelper('hint', 'sql', function (editor) {
+    var data = [],
+      doc = editor.getDoc(),
+      cur = doc.getCursor(),
+      // Get the current cursor position
+      current_cur = cur.ch,
+      // function context
+      ctx = {
+        editor: editor,
+        // URL for auto-complete
+        url: url_for('sqleditor.autocomplete', {
+          'trans_id': transId,
+        }),
+        data: data,
+        // Get the line number in the cursor position
+        current_line: cur.line,
+        /*
+         * Render function for hint to add our own class
+         * and icon as per the object type.
+         */
+        hint_render: function (elt, data_arg, cur_arg) {
+          var el = document.createElement('span');
+
+          switch (cur_arg.type) {
+          case 'database':
+            el.className = 'sqleditor-hint pg-icon-' + cur_arg.type;
+            break;
+          case 'datatype':
+            el.className = 'sqleditor-hint icon-type';
+            break;
+          case 'keyword':
+            el.className = 'fa fa-key';
+            break;
+          case 'table alias':
+            el.className = 'fa fa-at';
+            break;
+          default:
+            el.className = 'sqleditor-hint icon-' + cur_arg.type;
+          }
+
+          el.appendChild(document.createTextNode(cur_arg.text));
+          elt.appendChild(el);
+        },
+      };
+
+    data.push(doc.getValue());
+    // Get the text from start to the current cursor position.
+    data.push(
+      doc.getRange({
+        line: 0,
+        ch: 0,
+      }, {
+        line: ctx.current_line,
+        ch: current_cur,
+      })
+    );
+
+    return {
+      then: function (cb) {
+        var self_local = this;
+        // Make ajax call to find the autocomplete data
+        api.post(self_local.url, JSON.stringify(self_local.data))
+          .then((res) => {
+            var result = [];
+
+            _.each(res.data.data.result, function (obj, key) {
+              result.push({
+                text: key,
+                type: obj.object_type,
+                render: self_local.hint_render,
+              });
+            });
+
+            // Sort function to sort the suggestion's alphabetically.
+            result.sort(function (a, b) {
+              var textA = a.text.toLowerCase(),
+                textB = b.text.toLowerCase();
+              if (textA < textB) //sort string ascending
+                return -1;
+              if (textA > textB)
+                return 1;
+              return 0; //default return value (no sorting)
+            });
+
+            /*
+           * Below logic find the start and end point
+           * to replace the selected auto complete suggestion.
+           */
+            var token = self_local.editor.getTokenAt(cur),
+              start, end, search;
+            if (token.end > cur.ch) {
+              token.end = cur.ch;
+              token.string = token.string.slice(0, cur.ch - token.start);
+            }
+
+            if (token.string.match(/^[.`\w@]\w*$/)) {
+              search = token.string;
+              start = token.start;
+              end = token.end;
+            } else {
+              start = end = cur.ch;
+              search = '';
+            }
+
+            /*
+           * Added 1 in the start position if search string
+           * started with "." or "`" else auto complete of code mirror
+           * will remove the "." when user select any suggestion.
+           */
+            if (search.charAt(0) == '.' || search.charAt(0) == '``')
+              start += 1;
+
+            cb({
+              list: result,
+              from: {
+                line: self_local.current_line,
+                ch: start,
+              },
+              to: {
+                line: self_local.current_line,
+                ch: end,
+              },
+            });
+          })
+          .catch((err) => {
+            onFailure?.(err);
+          });
+      }.bind(ctx),
+    };
+  });
+}
+
+export default function Query() {
+  const classes = useStyles();
+  const editor = React.useRef();
+  const eventBus = useContext(QueryToolEventsContext);
+  const queryToolCtx = useContext(QueryToolContext);
+  const layoutEvenBus = useContext(LayoutEventsContext);
+  const lastSavedText = React.useRef('');
+  const markedLine = React.useRef(0);
+
+  const removeHighlightError = (cmObj)=>{
+    // Remove already existing marker
+    cmObj.removeLineClass(markedLine.current, 'wrap', 'CodeMirror-activeline-background');
+    markedLine.current = 0;
+  };
+  const highlightError = (cmObj, result)=>{
+    let errorLineNo = 0,
+      startMarker = 0,
+      endMarker = 0,
+      selectedLineNo = 0;
+
+    removeHighlightError(cmObj);
+
+    // In case of selection we need to find the actual line no
+    if (cmObj.getSelection().length > 0)
+      selectedLineNo = cmObj.getCursor(true).line;
+
+    // Fetch the LINE string using regex from the result
+    var line = /LINE (\d+)/.exec(result),
+      // Fetch the Character string using regex from the result
+      char = /Character: (\d+)/.exec(result);
+
+    // If line and character is null then no need to mark
+    if (line != null && char != null) {
+      errorLineNo = (parseInt(line[1]) - 1) + selectedLineNo;
+      var errorCharNo = (parseInt(char[1]) - 1);
+
+      /* We need to loop through each line till the error line and
+        * count the total no of character to figure out the actual
+        * starting/ending marker point for the individual line. We
+        * have also added 1 per line for the "\n" character.
+        */
+      var prevLineChars = 0;
+      for (let i = selectedLineNo > 0 ? selectedLineNo : 0; i < errorLineNo; i++)
+        prevLineChars += cmObj.getLine(i).length + 1;
+
+      /* Marker starting point for the individual line is
+        * equal to error character index minus total no of
+        * character till the error line starts.
+        */
+      startMarker = errorCharNo - prevLineChars;
+
+      // Find the next space from the character or end of line
+      var errorLine = cmObj.getLine(errorLineNo);
+
+      if (_.isUndefined(errorLine)) return;
+      endMarker = errorLine.indexOf(' ', startMarker);
+      if (endMarker < 0)
+        endMarker = errorLine.length;
+
+      // Mark the error text
+      cmObj.markText({
+        line: errorLineNo,
+        ch: startMarker,
+      }, {
+        line: errorLineNo,
+        ch: endMarker,
+      }, {
+        className: 'sql-editor-mark',
+      });
+
+      markedLine.current = errorLineNo;
+      cmObj.addLineClass(errorLineNo, 'wrap', 'CodeMirror-activeline-background');
+      cmObj.focus();
+      cmObj.setCursor(errorLineNo, 0);
+    }
+  };
+
+  const triggerExecution = (explainObject)=>{
+    if(queryToolCtx.params.is_query_tool) {
+      let query = editor.current?.getSelection() || editor.current?.getValue() || '';
+      if(query) {
+        eventBus.fireEvent(QUERY_TOOL_EVENTS.EXECUTION_START, query, explainObject);
+      }
+    } else {
+      eventBus.fireEvent(QUERY_TOOL_EVENTS.EXECUTION_START, null, null);
+    }
+  };
+
+  useEffect(()=>{
+    layoutEvenBus.registerListener(LAYOUT_EVENTS.ACTIVE, (currentTabId)=>{
+      currentTabId == PANELS.QUERY && editor.current.focus();
+    });
+
+    eventBus.registerListener(QUERY_TOOL_EVENTS.TRIGGER_EXECUTION, triggerExecution);
+
+    eventBus.registerListener(QUERY_TOOL_EVENTS.HIGHLIGHT_ERROR, (result)=>{
+      if(result) {
+        highlightError(editor.current, result);
+      } else {
+        removeHighlightError(editor.current);
+      }
+    });
+
+    eventBus.registerListener(QUERY_TOOL_EVENTS.LOAD_FILE, (fileName)=>{
+      queryToolCtx.api.post(url_for('sqleditor.load_file'), {
+        'file_name': decodeURI(fileName),
+      }).then((res)=>{
+        editor.current.setValue(res.data);
+        lastSavedText.current = res.data;
+        eventBus.fireEvent(QUERY_TOOL_EVENTS.LOAD_FILE_DONE, fileName, true);
+        eventBus.fireEvent(QUERY_TOOL_EVENTS.QUERY_CHANGED, isDirty());
+      }).catch((err)=>{
+        eventBus.fireEvent(QUERY_TOOL_EVENTS.LOAD_FILE_DONE, null, false);
+        eventBus.fireEvent(QUERY_TOOL_EVENTS.HANDLE_API_ERROR, err);
+      });
+    });
+
+    eventBus.registerListener(QUERY_TOOL_EVENTS.SAVE_FILE, (fileName)=>{
+      let editorValue = editor.current.getValue();
+      queryToolCtx.api.post(url_for('sqleditor.save_file'), {
+        'file_name': decodeURI(fileName),
+        'file_content': editor.current.getValue(),
+      }).then(()=>{
+        lastSavedText.current = editorValue;
+        eventBus.fireEvent(QUERY_TOOL_EVENTS.SAVE_FILE_DONE, fileName, true);
+        eventBus.fireEvent(QUERY_TOOL_EVENTS.QUERY_CHANGED, isDirty());
+        Notifier.success(gettext('File saved successfully.'));
+      }).catch((err)=>{
+        eventBus.fireEvent(QUERY_TOOL_EVENTS.SAVE_FILE_DONE, null, false);
+        eventBus.fireEvent(QUERY_TOOL_EVENTS.HANDLE_API_ERROR, err);
+      });
+    });
+
+    eventBus.registerListener(QUERY_TOOL_EVENTS.EDITOR_EXEC_CMD, (cmd='')=>{
+      editor.current?.execCommand(cmd);
+    });
+    eventBus.registerListener(QUERY_TOOL_EVENTS.COPY_TO_EDITOR, (text)=>{
+      editor.current?.setValue(text);
+      eventBus.fireEvent(QUERY_TOOL_EVENTS.FOCUS_PANEL, PANELS.QUERY);
+      setTimeout(()=>{
+        editor.current?.focus();
+        editor.current?.setCursor(editor.current.lineCount(), 0);
+      }, 250);
+    });
+    eventBus.registerListener(QUERY_TOOL_EVENTS.EDITOR_FIND_REPLACE, (replace=false)=>{
+      editor.current?.focus();
+      let key = {
+        keyCode: 70, metaKey: false, ctrlKey: true, shiftKey: replace, altKey: false,
+      };
+      if(isMac()) {
+        key.metaKey = true;
+        key.ctrlKey = false;
+        key.shiftKey = false;
+        key.altKey = true;
+      }
+      editor.current?.triggerOnKeyDown(
+        new KeyboardEvent('keydown', key)
+      );
+    });
+    eventBus.registerListener(QUERY_TOOL_EVENTS.EDITOR_SET_SQL, (value, focus=true)=>{
+      focus && editor.current?.focus();
+      editor.current?.setValue(value);
+    });
+    eventBus.registerListener(QUERY_TOOL_EVENTS.TRIGGER_QUERY_CHANGE, ()=>{
+      change();
+    });
+    eventBus.registerListener(QUERY_TOOL_EVENTS.WARN_SAVE_TEXT_CLOSE, ()=>{
+      if(!isDirty() || !queryToolCtx.preferences?.sqleditor.prompt_save_query_changes) {
+        eventBus.fireEvent(QUERY_TOOL_EVENTS.WARN_TXN_CLOSE);
+        return;
+      }
+      queryToolCtx.modal.showModal(gettext('Save query changes?'), (closeModal)=>(
+        <ConfirmSaveContent
+          closeModal={closeModal}
+          text={gettext('The query text has changed. Do you want to save changes?')}
+          onDontSave={()=>{
+            eventBus.fireEvent(QUERY_TOOL_EVENTS.WARN_TXN_CLOSE);
+          }}
+          onSave={()=>{
+            eventBus.registerListener(QUERY_TOOL_EVENTS.SAVE_FILE_DONE, (_f, success)=>{
+              if(success) {
+                eventBus.fireEvent(QUERY_TOOL_EVENTS.WARN_TXN_CLOSE);
+              }
+            }, true);
+            eventBus.fireEvent(QUERY_TOOL_EVENTS.TRIGGER_SAVE_FILE);
+          }}
+        />
+      ));
+    });
+    eventBus.registerListener(QUERY_TOOL_EVENTS.TRIGGER_FORMAT_SQL, ()=>{
+      let selection = true, sql = editor.current?.getSelection();
+      if(sql == '') {
+        sql = editor.current.getValue();
+        selection = false;
+      }
+      queryToolCtx.api.post(url_for('sql.format'), {
+        'sql': sql,
+      }).then((res)=>{
+        if(selection) {
+          editor.current.replaceSelection(res.data.data.sql, 'around');
+        } else {
+          editor.current.setValue(res.data.data.sql);
+        }
+      }).catch(()=>{/* failure should be ignored */});
+    });
+
+    editor.current.focus();
+  }, []);
+
+  useEffect(()=>{
+    registerAutocomplete(queryToolCtx.api, queryToolCtx.params.trans_id, (err)=>{
+      eventBus.fireEvent(QUERY_TOOL_EVENTS.HANDLE_API_ERROR, err);
+    });
+  }, [queryToolCtx.params.trans_id]);
+
+  const isDirty = ()=>lastSavedText.current !== editor.current.getValue();
+
+  const cursorActivity = useCallback((cmObj)=>{
+    const c = cmObj.getCursor();
+    eventBus.fireEvent(QUERY_TOOL_EVENTS.CURSOR_ACTIVITY, [c.line+1, c.ch+1]);
+  }, []);
+
+  const change = useCallback(()=>{
+    eventBus.fireEvent(QUERY_TOOL_EVENTS.QUERY_CHANGED, isDirty());
+  }, []);
+
+  return <CodeMirror
+    currEditor={(obj)=>{
+      editor.current=obj;
+    }}
+    value={''}
+    className={classes.sql}
+    events={{
+      'focus': cursorActivity,
+      'cursorActivity': cursorActivity,
+      'change': change,
+    }}
+    disabled={!queryToolCtx.params.is_query_tool}
+    autocomplete={true}
+  />;
+}
diff --git a/web/pgadmin/tools/sqleditor/static/js/components/sections/QueryHistory.jsx b/web/pgadmin/tools/sqleditor/static/js/components/sections/QueryHistory.jsx
new file mode 100644
index 000000000..cbbca3486
--- /dev/null
+++ b/web/pgadmin/tools/sqleditor/static/js/components/sections/QueryHistory.jsx
@@ -0,0 +1,500 @@
+/////////////////////////////////////////////////////////////
+//
+// pgAdmin 4 - PostgreSQL Tools
+//
+// Copyright (C) 2013 - 2022, The pgAdmin Development Team
+// This software is released under the PostgreSQL Licence
+//
+//////////////////////////////////////////////////////////////
+import { makeStyles } from '@material-ui/styles';
+import React from 'react';
+import { PANELS, QUERY_TOOL_EVENTS } from '../QueryToolConstants';
+import gettext from 'sources/gettext';
+import _ from 'lodash';
+import clsx from 'clsx';
+import { Box, Grid, List, ListItem, ListSubheader } from '@material-ui/core';
+import url_for from 'sources/url_for';
+import { QueryToolContext, QueryToolEventsContext } from '../QueryToolComponent';
+import moment from 'moment';
+import PlayArrowRoundedIcon from '@material-ui/icons/PlayArrowRounded';
+import AssessmentRoundedIcon from '@material-ui/icons/AssessmentRounded';
+import ExplicitRoundedIcon from '@material-ui/icons/ExplicitRounded';
+import { SaveDataIcon, CommitIcon, RollbackIcon } from '../../../../../../static/js/components/ExternalIcon';
+import { InputSwitch } from '../../../../../../static/js/components/FormComponents';
+import CodeMirror from '../../../../../../static/js/components/CodeMirror';
+import { DefaultButton } from '../../../../../../static/js/components/Buttons';
+import { useDelayedCaller } from '../../../../../../static/js/custom_hooks';
+import Notifier from '../../../../../../static/js/helpers/Notifier';
+import Loader from 'sources/components/Loader';
+import { LayoutEventsContext, LAYOUT_EVENTS } from '../../../../../../static/js/helpers/Layout';
+import PropTypes from 'prop-types';
+import { parseApiError } from '../../../../../../static/js/api_instance';
+import * as clipboard from '../../../../../../static/js/clipboard';
+
+const useStyles = makeStyles((theme)=>({
+  leftRoot: {
+    display: 'flex',
+    flexDirection: 'column',
+    backgroundColor: theme.otherVars.editorToolbarBg,
+    ...theme.mixins.panelBorder.right,
+  },
+  listRoot: {
+    ...theme.mixins.panelBorder.top,
+  },
+  listSubheader: {
+    padding: '0.25rem',
+    lineHeight: 'unset',
+    color: theme.palette.text.muted,
+    backgroundColor: theme.palette.background.default,
+    ...theme.mixins.panelBorder.bottom,
+    ...theme.mixins.fontSourceCode,
+  },
+  removePadding: {
+    padding: 0,
+  },
+  fontSourceCode:{
+    ...theme.mixins.fontSourceCode,
+    userSelect: 'text',
+  },
+  itemError: {
+    backgroundColor: theme.palette.error.light,
+    '&.Mui-selected': {
+      backgroundColor: theme.palette.error.light,
+      '&:hover': {
+        backgroundColor: theme.palette.error.light,
+      }
+    }
+  },
+  detailsQuery: {
+    marginTop: '0.5rem',
+    ...theme.mixins.panelBorder.all,
+  },
+  copyBtn: {
+    borderRadius: 0,
+    paddingLeft: '8px',
+    paddingRight: '8px',
+    borderTop: 'none',
+    borderLeft: 'none',
+    borderColor: theme.otherVars.borderColor,
+    fontSize: '13px',
+  },
+  infoHeader: {
+    fontSize: '13px',
+    padding: '0.5rem',
+    backgroundColor: theme.otherVars.editorToolbarBg,
+  },
+  removeBtnMargin: {
+    marginLeft: '0.25rem',
+  }
+}));
+
+export const QuerySources = {
+  EXECUTE: {
+    ICON_CSS_CLASS: 'fa fa-play',
+  },
+  EXPLAIN: {
+    ICON_CSS_CLASS: 'fa fa-hand-pointer',
+  },
+  EXPLAIN_ANALYZE: {
+    ICON_CSS_CLASS: 'fa fa-list-alt',
+  },
+  COMMIT: {
+    ICON_CSS_CLASS: 'pg-font-icon icon-commit',
+  },
+  ROLLBACK: {
+    ICON_CSS_CLASS: 'pg-font-icon icon-rollback',
+  },
+  SAVE_DATA: {
+    ICON_CSS_CLASS: 'pg-font-icon icon-save_data_changes',
+  },
+  VIEW_DATA: {
+    ICON_CSS_CLASS: 'pg-font-icon icon-view_data',
+  },
+};
+
+
+class QueryHistoryUtils {
+  constructor() {
+    this._entries = [];
+    this.showInternal = true;
+  }
+
+  dateAsGroupKey(date) {
+    return moment(date).format('YYYY MM DD');
+  }
+
+  getItemKey(entry) {
+    return this.dateAsGroupKey(entry.start_time) + this.formatEntryDate(entry.start_time) + (entry.subKey ?? '');
+  }
+
+  getDateFormatted(date) {
+    return date.toLocaleDateString();
+  }
+
+  formatEntryDate(date) {
+    return moment(date).format('HH:mm:ss');
+  }
+
+  isDaysBefore(date, before) {
+    return (
+      this.getDateFormatted(date) ===
+      this.getDateFormatted(moment().subtract(before, 'days').toDate())
+    );
+  }
+
+  getDatePrefix(date) {
+    let prefix = '';
+    if (this.isDaysBefore(date, 0)) {
+      prefix = 'Today - ';
+    } else if (this.isDaysBefore(date, 1)) {
+      prefix = 'Yesterday - ';
+    }
+    return prefix;
+  }
+
+  addEntry(entry) {
+    entry.groupKey = this.dateAsGroupKey(entry.start_time);
+    entry.itemKey = this.getItemKey(entry);
+    let existEntry = _.find(this._entries, (e)=>e.itemKey==entry.itemKey);
+    if(existEntry) {
+      entry.itemKey = this.getItemKey(entry) + _.uniqueId();
+    }
+    let insertIndex = _.sortedIndexBy(this._entries, entry, (e)=>e.itemKey);
+    this._entries = [
+      ...this._entries.slice(0, insertIndex),
+      entry,
+      ...this._entries.slice(insertIndex),
+    ];
+  }
+
+  getEntries() {
+    if(!this.showInternal) {
+      return this._entries.filter((e)=>!e.is_pgadmin_query);
+    }
+    return this._entries;
+  }
+
+  getEntry(itemKey) {
+    return _.find(this.getEntries(), (e)=>e.itemKey==itemKey);
+  }
+
+  getGroupHeader(entry) {
+    return this.getDatePrefix(entry.start_time)+this.getDateFormatted(entry.start_time);
+  }
+
+  getGroups() {
+    return _.sortedUniqBy(this.getEntries().map((e)=>[e.groupKey, this.getGroupHeader(e)]), (g)=>g[0]).reverse();
+  }
+
+  getGroupEntries(groupKey) {
+    return this.getEntries().filter((e)=>e.groupKey==groupKey).reverse();
+  }
+
+  getNextItemKey(currKey) {
+    let nextIndex = this.getEntries().length-1;
+    if(currKey) {
+      let currIndex = _.findIndex(this.getEntries(), (e)=>e.itemKey==currKey);
+      if(currIndex == 0) {
+        nextIndex = currIndex;
+      } else {
+        nextIndex = currIndex - 1;
+      }
+    }
+    return this.getEntries()[nextIndex]?.itemKey;
+  }
+
+  getPrevItemKey(currKey) {
+    let nextIndex = this.getEntries().length-1;
+    if(currKey) {
+      let currIndex = _.findIndex(this.getEntries(), (e)=>e.itemKey==currKey);
+      if(currIndex == this.getEntries().length-1) {
+        nextIndex = currIndex;
+      } else {
+        nextIndex = currIndex + 1;
+      }
+    }
+    return this.getEntries()[nextIndex]?.itemKey;
+  }
+
+  clear(itemKey) {
+    if(itemKey) {
+      let nextKey = this.getNextItemKey(itemKey);
+      let removeIdx = _.findIndex(this._entries, (e)=>e.itemKey==itemKey);
+      this._entries.splice(removeIdx, 1);
+      return nextKey;
+    } else {
+      this._entries = [];
+    }
+  }
+
+  size() {
+    return this._entries.length;
+  }
+}
+
+function QuerySourceIcon({source}) {
+  switch(JSON.stringify(source)) {
+  case JSON.stringify(QuerySources.EXECUTE):
+    return <PlayArrowRoundedIcon style={{marginLeft: '-4px'}}/>;
+  case JSON.stringify(QuerySources.EXPLAIN):
+    return <ExplicitRoundedIcon/>;
+  case JSON.stringify(QuerySources.EXPLAIN_ANALYZE):
+    return <AssessmentRoundedIcon/>;
+  case JSON.stringify(QuerySources.COMMIT):
+    return <CommitIcon style={{marginLeft: '-4px'}}/>;
+  case JSON.stringify(QuerySources.ROLLBACK):
+    return <RollbackIcon style={{marginLeft: '-4px'}}/>;
+  case JSON.stringify(QuerySources.SAVE_DATA):
+    return <SaveDataIcon style={{marginLeft: '-4px'}}/>;
+  case JSON.stringify(QuerySources.VIEW_DATA):
+    return <SaveDataIcon style={{marginLeft: '-4px'}}/>;
+  default:
+    return <></>;
+  }
+}
+QuerySourceIcon.propTypes = {
+  source: PropTypes.object,
+};
+
+function HistoryEntry({entry, formatEntryDate, itemKey, selectedItemKey, onClick}) {
+  const classes = useStyles();
+  return <ListItem tabIndex="0" ref={(ele)=>{
+    selectedItemKey==itemKey && ele && ele.scrollIntoView({
+      block: 'center',
+      behavior: 'smooth',
+    });
+  }} className={clsx(classes.fontSourceCode, entry.status ? '' : classes.itemError)} selected={selectedItemKey==itemKey} onClick={onClick}>
+    <Box whiteSpace="nowrap" textOverflow="ellipsis" overflow="hidden" >
+      <QuerySourceIcon source={entry.query_source}/>
+      {entry.query}
+    </Box>
+    <Box fontSize="12px">
+      {formatEntryDate(entry.start_time)}
+    </Box>
+  </ListItem>;
+}
+
+const EntryPropType = PropTypes.shape({
+  info: PropTypes.string,
+  status: PropTypes.bool,
+  start_time: PropTypes.objectOf(Date),
+  query: PropTypes.string,
+  row_affected: PropTypes.number,
+  total_time: PropTypes.string,
+  message: PropTypes.string,
+  query_source: PropTypes.object,
+  is_pgadmin_query: PropTypes.bool,
+});
+HistoryEntry.propTypes = {
+  entry: EntryPropType,
+  formatEntryDate: PropTypes.func,
+  itemKey: PropTypes.string,
+  selectedItemKey: PropTypes.string,
+  onClick: PropTypes.func,
+};
+
+function QueryHistoryDetails({entry}) {
+  const classes = useStyles();
+  const [copyText, setCopyText] = React.useState(gettext('Copy'));
+  const eventBus = React.useContext(QueryToolEventsContext);
+  const revertCopiedText = useDelayedCaller(()=>{
+    setCopyText(gettext('Copy'));
+  });
+
+  const onCopyClick = React.useCallback(()=>{
+    clipboard.copyToClipboard(entry.query);
+    setCopyText(gettext('Copied!'));
+    revertCopiedText(1500);
+  }, [entry]);
+
+  const onCopyToEditor = React.useCallback(()=>{
+    eventBus.fireEvent(QUERY_TOOL_EVENTS.COPY_TO_EDITOR, entry.query);
+  }, [entry]);
+
+  if(!entry) {
+    return <></>;
+  }
+
+  return (
+    <>
+      {entry.info && <Box className={classes.infoHeader}>{entry.info}</Box>}
+      <Box padding="0.5rem">
+        <Grid container>
+          <Grid item sm={4}>{entry.start_time.toLocaleDateString() + ' ' + entry.start_time.toLocaleTimeString()}</Grid>
+          <Grid item sm={4}>{entry?.row_affected > 0 && entry.row_affected}</Grid>
+          <Grid item sm={4}>{entry.total_time}</Grid>
+        </Grid>
+        <Grid container>
+          <Grid item sm={4}>{gettext('Date')}</Grid>
+          <Grid item sm={4}>{gettext('Rows affected')}</Grid>
+          <Grid item sm={4}>{gettext('Duration')}</Grid>
+        </Grid>
+        <Box className={classes.detailsQuery}>
+          <DefaultButton size="xs" className={classes.copyBtn} onClick={onCopyClick}>{copyText}</DefaultButton>
+          <DefaultButton size="xs" className={classes.copyBtn} onClick={onCopyToEditor}>{gettext('Copy to Query Editor')}</DefaultButton>
+          <CodeMirror
+            value={entry.query}
+            options={{
+              foldGutter: false,
+              lineNumbers: false,
+              gutters: [],
+              readOnly: true,
+            }}
+          />
+        </Box>
+        <Box marginTop="0.5rem">
+          <Box>{gettext('Messages')}</Box>
+          <Box className={classes.fontSourceCode} fontSize="13px" whiteSpace="pre-wrap">{entry.message}</Box>
+        </Box>
+      </Box>
+    </>
+  );
+}
+
+QueryHistoryDetails.propTypes = {
+  entry: EntryPropType,
+};
+
+export function QueryHistory() {
+  const qhu = React.useRef(new QueryHistoryUtils());
+  const queryToolCtx = React.useContext(QueryToolContext);
+  const classes = useStyles();
+  const eventBus = React.useContext(QueryToolEventsContext);
+  const [selectedItemKey, setSelectedItemKey] = React.useState(1);
+  const [showInternal, setShowInternal] = React.useState(true);
+  const [loaderText, setLoaderText] = React.useState('');
+  const [,refresh] = React.useState({});
+  const selectedEntry = qhu.current.getEntry(selectedItemKey);
+  const layoutEvenBus = React.useContext(LayoutEventsContext);
+  const listRef = React.useRef();
+
+  React.useEffect(async ()=>{
+    layoutEvenBus.registerListener(LAYOUT_EVENTS.ACTIVE, (currentTabId)=>{
+      currentTabId == PANELS.HISTORY && listRef.current.focus();
+    });
+
+    setLoaderText(gettext('Fetching history...'));
+    try {
+      let {data: respData} = await queryToolCtx.api.get(url_for('sqleditor.get_query_history', {
+        'trans_id': queryToolCtx.params.trans_id,
+      }));
+      respData.data.result.forEach((h)=>{
+        h = JSON.parse(h);
+        h.start_time_orig = h.start_time;
+        h.start_time = new Date(h.start_time);
+        qhu.current.addEntry(h);
+      });
+      setSelectedItemKey(qhu.current.getNextItemKey());
+    } catch (error) {
+      console.error(error);
+      Notifier.error(gettext('Failed to fetch query history.') + parseApiError(error));
+    }
+    setLoaderText('');
+
+    const pushHistory = (h)=>{
+      qhu.current.addEntry(h);
+      refresh({});
+    };
+
+    listRef.current.focus();
+    eventBus.registerListener(QUERY_TOOL_EVENTS.PUSH_HISTORY, pushHistory);
+    return ()=>eventBus.deregisterListener(QUERY_TOOL_EVENTS.PUSH_HISTORY, pushHistory);
+  }, []);
+
+  const onRemove = async ()=>{
+    setLoaderText(gettext('Removing history entry...'));
+    try {
+      await queryToolCtx.api.delete(url_for('sqleditor.clear_query_history', {
+        'trans_id': queryToolCtx.params.trans_id,
+      }), {
+        data: {
+          query: selectedEntry.query,
+          start_time: selectedEntry.start_time,
+        }
+      });
+      setSelectedItemKey(qhu.current.clear(selectedItemKey));
+    } catch (error) {
+      console.error(error);
+      Notifier.error(gettext('Failed to remove query history.') + parseApiError(error));
+    }
+    setLoaderText('');
+  };
+
+  const onRemoveAll = React.useCallback(()=>{
+    queryToolCtx.modal.confirm(gettext('Clear history'),
+      gettext('Are you sure you wish to clear the history?') + '</br>' +
+      gettext('This will remove all of your query history from this and other sessions for this database.'),
+      async function() {
+        setLoaderText(gettext('Removing history...'));
+        try {
+          await queryToolCtx.api.delete(url_for('sqleditor.clear_query_history', {
+            'trans_id': queryToolCtx.params.trans_id,
+          }));
+          qhu.current.clear();
+          setSelectedItemKey(null);
+        } catch (error) {
+          console.error(error);
+          Notifier.error(gettext('Failed to remove query history.') + parseApiError(error));
+        }
+        setLoaderText('');
+      },
+      function() {
+        return true;
+      }
+    );
+
+  }, []);
+
+  const onKeyPressed = (e) => {
+    if (e.keyCode == '38') {
+      e.preventDefault();
+      setSelectedItemKey(qhu.current.getPrevItemKey(selectedItemKey));
+    } else if (e.keyCode == '40') {
+      e.preventDefault();
+      setSelectedItemKey(qhu.current.getNextItemKey(selectedItemKey));
+    }
+  };
+
+  return (
+    <>
+      <Loader message={loaderText} />
+      {React.useMemo(()=>(
+        <Box display="flex" height="100%">
+          <Box flexBasis="50%" maxWidth="50%" className={classes.leftRoot}>
+            <Box padding="0.25rem" display="flex">
+              {gettext('Show queries generated internally by pgAdmin?')}
+              <InputSwitch value={showInternal} onChange={(e)=>{
+                setShowInternal(e.target.checked);
+                qhu.current.showInternal = e.target.checked;
+                setSelectedItemKey(qhu.current.getNextItemKey());
+              }} />
+              <Box marginLeft="auto">
+                <DefaultButton size="small" disabled={!selectedItemKey} onClick={onRemove}>Remove</DefaultButton>
+                <DefaultButton size="small" disabled={!qhu.current?.getGroups()?.length}
+                  className={classes.removeBtnMargin} onClick={onRemoveAll}>Remove All</DefaultButton>
+              </Box>
+            </Box>
+            <Box flexGrow="1" overflow="auto" className={classes.listRoot}>
+              <List innerRef={listRef} className={classes.root} subheader={<li />} tabIndex="0" onKeyDown={onKeyPressed}>
+                {qhu.current.getGroups().map(([groupKey, groupHeader]) => (
+                  <ListItem key={`section-${groupKey}`} className={classes.removePadding}>
+                    <List className={classes.removePadding}>
+                      <ListSubheader className={classes.listSubheader}>{groupHeader}</ListSubheader>
+                      {qhu.current.getGroupEntries(groupKey).map((entry) => (
+                        <HistoryEntry key={entry.itemKey} entry={entry} formatEntryDate={qhu.current.formatEntryDate}
+                          itemKey={entry.itemKey} selectedItemKey={selectedItemKey} onClick={()=>{setSelectedItemKey(entry.itemKey);}}/>
+                      ))}
+                    </List>
+                  </ListItem>
+                ))}
+              </List>
+            </Box>
+          </Box>
+          <Box flexBasis="50%" maxWidth="50%" overflow="auto">
+            <QueryHistoryDetails entry={selectedEntry}/>
+          </Box>
+        </Box>
+      ), [selectedItemKey, showInternal, qhu.current.size()])}
+    </>
+  );
+}
